"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var glob = __importStar(require("glob"));
var path = __importStar(require("path"));
var fs = __importStar(require("fs-extra"));
exports.globTestIds = function (_a) {
    var idsLocation = _a.idsLocation, output = _a.output;
    try {
        var allIds = glob
            .sync(path.join(process.cwd(), idsLocation))
            .map(function (filename) { return ({
            filename: filename,
            file: fs.readFileSync(filename, "utf8")
        }); })
            .map(function (_a) {
            var filename = _a.filename, file = _a.file;
            return ({
                filename: filename,
                file: JSON.parse(file)
            });
        })
            .reduce(function (ids, _a) {
            var filename = _a.filename, file = _a.file;
            file.forEach(function (testId) {
                if (testId in ids) {
                    throw new Error("Duplicate test id " + testId + " in " + filename);
                }
                ids[testId] = testId;
            });
            return ids;
        }, {});
        fs.mkdirpSync(path.dirname(output));
        var outFile = path.join(process.cwd(), output);
        fs.writeFileSync(outFile, JSON.stringify(allIds, null, 2));
        console.log(Object.keys(allIds).length + " test ids written to " + outFile);
        process.exit(0);
    }
    catch (e) {
        console.error(e);
        process.exit(1);
    }
};
